-- ACCOUNT APPROVAL PROCESS: Creating a VIEW of ALL pre-approved users
CREATE VIEW GET_ALL_APPROVED_USERS AS
SELECT a.OWNER_ID AS "ID" -- You can only Intersect if all Selected columns are a match! Choose only "ID"
FROM ACCOUNTLIST a 
WHERE APPROVED = 'N'
INTERSECT 
SELECT a2.OWNER_ID
FROM ACCOUNTLIST a2 
WHERE a2.APPROVED = 'Y' -- APPROVED_2;

-- Using above View. **THIS MAY RETURN MORE THAN 1 OWNER_ID AND THEREFORE DOES NOT WORK.**
UPDATE ACCOUNTLIST 
SET APPROVED = 'Y'
WHERE OWNER_ID = (SELECT * FROM GET_ALL_APPROVED_USERS);

-- OR, The 1-by-1 approach
UPDATE ACCOUNTLIST 
SET APPROVED = 'Y'
WHERE OWNER_ID = ? 

-- OR, do the easy thing
UPDATE ACCOUNTLIST SET APPROVED = 'Y' WHERE APPROVED = 'N';

-- VIEWING ALL OF A CUSTOMER'S ACCOUNTS
CREATE OR REPLACE VIEW ACCOUNTS_OF_CUSTOMER AS
SELECT u.NAME, a.OWNER_ID AS "ID", a.ACCOUNT_NO AS "NO", a.APPROVED, a.KIND, a.BALANCE
FROM ACCOUNTLIST a
JOIN USERLIST u ON a.OWNER_ID = u.USER_ID;

SELECT * 
FROM ACCOUNTS_OF_CUSTOMER
WHERE NAME = 'Justin Cheesy' -- ?

-- VIEWING ALL OF A CUSTOMER'S TRANSACTIONS
-- Make a View that joins the AccountList with a User's Name
CREATE OR REPLACE VIEW ACCOUNTS_BY_OWNER_NAME AS
SELECT a.ACCOUNT_NO AS "NO", u.NAME 
FROM ACCOUNTLIST a 
JOIN USERLIST u ON a.OWNER_ID = u.USER_ID;

-- Make a View that finds distinct Transaction records linked to the Accounts of a User
CREATE OR REPLACE VIEW TRANSACTIONS_OF_ACCOUNTS_BY_OWNER_NAME AS
SELECT DISTINCT NAME, TRANSACTION_ID, SOURCE_NO AS "SOURCE", TARGET_NO AS "TARGET", AMOUNT, T_DATE 
FROM ACCOUNTS_BY_OWNER_NAME a
JOIN TRANSACTIONS t ON "NO" = t.SOURCE_NO OR "NO" = t.TARGET_NO;

SELECT *
FROM TRANSACTIONS_OF_ACCOUNTS_BY_OWNER_NAME
WHERE NAME = 'Ellen Ferdinand' -- ?
ORDER BY T_DATE;

--
--
CREATE OR REPLACE VIEW NAME_OF_ACCOUNT_OWNER AS
SELECT NAME FROM USERLIST u 
JOIN ACCOUNTLIST a ON a.OWNER_ID = u.USER_ID;